class ComplaintsController < ApplicationController
  before_action :set_complaint, only: [:show, :update, :destroy, :like]

  # POST /complaints
  # POST /complaints.json
  def create
    @complaint = Complaint.new(complaint_params)
    @complaint.user = current_user
    @complaint.object = params[:object]
    
    respond_to do |format|
      if complaint_repository.report @complaint
        format.html { redirect_to @complaint, notice: 'complaint was successfully created.' }
      else
        format.html { render :new }
      end
    end
  end

  # DELETE /complaints/1
  # DELETE /complaints/1.json
  def destroy
    complaint_repository.destroy @complaint

    respond_to do |format|
      format.html { redirect_to complaints_url, notice: 'Complaint was successfully destroyed.' }
    end
  end


  private

  def set_complaint
    @complaint = complaint_repository.find params[:id]
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def complaint_params
    params.require(:complaint).permit(:object, :message, :description)
  end

end
