module OrientDb
  class CollectionRepository < Base
    include OrientDb::Methods::EdgeMethods

    def build_object(args={})
      Collection.new(
          id: args['@rid'],
          name: args['name']
      )
    end

    def create_bookmarks_collection(user)
      bookmarks = Bookmarks.new(owner: user)

      if !has_bookmarks?(user)
        create bookmarks
      end
    end

    def create(object)
      super(object)

      # the collection belongs to user
      create_edge "BelongsTo", object.id, object.owner.rid
    end

    def all(user)
      []
    end

    private

    def odb_class
      "Collection"
    end

  end
end
