module OrientDb
  class LearningObjectRepository < Base
    include OrientDb::Methods::EdgeMethods
    include RepositoriesProxy

      def report(complaint)
        if edge_exists?(odb_class, complaint.user.id, complaint.object.id)
          raise "The user has already been reported"
        end

        connection.command "CREATE EDGE Complaint FROM #{complaint.user.id} TO #{complaint.object.id} SET message = #{complaint.message}, description = #{complaint.description}"
      end

      def destroy(object)
        if !edge_exists?(odb_class, complaint.user.id, complaint.object.id)
          raise "The user has not already been reported"
        end

        connection.command "DELETE EDGE Complaint FROM #{complaint.user.id} TO #{complaint.object.id}"
      end

      def build_object(args={})
        Complaint.new(args)
      end

      protected

      def odb_class
        "Complaint"
      end

  end
end
